import type { Parinfer, ParinferError } from "parinfer";
declare global {
    interface Window {
        parinfer?: Parinfer;
    }
}
import { StateEffectType, StateField } from "@codemirror/state";
import { EditorView } from "@codemirror/view";
export declare const setEnabledEffect: StateEffectType<boolean>;
export type ParinferMode = "smart" | "indent" | "paren";
export declare const switchModeEffect: StateEffectType<ParinferMode>;
interface InvertibleFieldValue<T> {
    id: number;
    invertsId?: number;
    previous: T | null;
    current: T | null;
}
export declare function switchMode(view: EditorView, mode: ParinferMode): void;
export declare function disableParinfer(view: EditorView): void;
export declare function enableParinfer(view: EditorView): void;
export declare function parinferExtension(): (import("@codemirror/state").Extension | StateField<boolean> | StateField<ParinferMode> | StateField<InvertibleFieldValue<ParinferError>>)[];
export {};
//# sourceMappingURL=cm6-parinfer.d.ts.map